#include "Test.h"
#include "Matrix.h"
#include <cmath>

/**
Es wird eine 3*4 Matrix angelegt und einige Werte
werden gesetzt, die dann ausgelesen werden.
Die Matrix wird dann in eine 8*2 Matrix gendert
und wiederum mit Werten belegt und ausgelesen werden.
Liefert das Auslesen die erwarteten Werte, wird true
geliefert
*/
bool test1()
   {
   const int ze=3;
   const int sp=4;
   Matrix m1(ze,sp);
 
   for (int i = 0; i < ze; ++i) {
      for (int j=0; j < sp; ++j) {
         m1.Setze(i,j, i*sp + j*2);
         }
      } // for i

   for (int i = 0; i < ze; ++i) {
      for (int j=0; j < sp; ++j) {
         if (m1.Lese(i,j) !=  (i*sp + j*2)) {
            return false;
            }
         }
      } // for i
  
   return true;
   }// Matrix wird auf dem Stack automatisch zerstoert


/**
Es wird eine 3*4 Matrix angelegt und einige Werte
werden gesetzt, die dann ausgelesen werden.
Die Matrix wird dann in eine 8*2 Matrix gendert
und wiederum mit Werten belegt und ausgelesen werden.

Anschlieend wird sie in eine 8*2-Matrix gendert.
Liefert das Auslesen die erwarteten Werte, wird true
geliefert

*/
bool test2()
   {
   int ze=3;
   int sp=4;
   Matrix m1(ze, sp);

   for (int i = 0; i < ze; ++i) {
      for (int j=0; j < sp; ++j) {
         m1.Setze(i,j, i*sp + j*2);
         }
      } // for i

   for (int i = 0; i < ze; ++i) {
      for (int j=0; j < sp; ++j) {
         if (m1.Lese(i,j) !=  (i*sp + j*2)) {
            return false;
            }
         }
      } // for i

   ze=8;
   sp=2;
   m1.Resize(ze, sp);

   for (int i = 0; i < ze; ++i) {
      for (int j=0; j < sp; ++j) {
         m1.Setze(i,j, i*sp + j*2);
         }
      } // for i

   for (int i = 0; i < ze; ++i) {
      for (int j=0; j < sp; ++j) {
         if (m1.Lese(i,j) !=  (i*sp + j*2)) {
            return false;
            }
         }
      } // for i

   
   return true;
   }



/**
Es werden zwei Matrizen angelegt und die Summe mit Add
ermittelt. Es wird berprft, ob die Summe geliefert wird.
*/
bool testAdd()
   {
      int ze = 3;
      int sp = 4;
      Matrix m1(ze, sp);
      Matrix m2(ze, sp);

      BasisTyp wert1(2.4);
      BasisTyp wert2(2.5);
      for (int i = 0; i < ze; ++i) {
         for (int j = 0; j < sp; ++j) {
            m1.Setze(i, j, wert1);
            m2.Setze(i, j, wert2);
         }
      } // for i

      Matrix m3(ze, sp);
      BasisTyp  EPS = 0.00001;
      Add(m1, m2, m3);
      for (int i = 0; i < ze; ++i) {
         for (int j = 0; j < sp; ++j) {
            if (fabs(m3.Lese(i, j) - (wert1 + wert2)) > EPS) {
               return false;
            }
         }
      } // for i

      return true;
}

